#include <stdio.h>
#include <stdlib.h>
#include "../../include/devmud.h"

struct interface config_supplies[] = {
	{NULL,NULL,NULL,NULL}
};

struct interface config_uses[] = {
	{NULL,NULL,NULL,NULL}
};

void config_use_functions(struct interface *it)
{
	return;
}

int config_initialize(void)
{
	return(0);
}

/* TODO name=value stuff. nums default to port */
int config_start(void)
{
	struct module_handle *socket_handle, *bigworld_handle;
	struct interface *temp;
	static void (*config_port)(int port);

	socket_handle = load_module("socket");
	bigworld_handle = load_module("bigworld");

	if ((*socket_handle->initialize)() != 0)
	{
		fprintf(stderr,"Socket failed to initialize.\n");
		exit(1);
	}
	if ((*bigworld_handle->initialize)() != 0)
	{
		fprintf(stderr,"World failed to initialize.\n");
		exit(1);
	}

	bigworld_handle->use_functions(socket_handle->supplies);
	if (main_argc == 2)
	{
		temp = socket_handle->supplies;
		while (temp->name != NULL)
		{
			if (!strcmp(temp->name,"config_port"))
			{
				config_port = temp->function;
			}
			temp++;
		}
		if (config_port == NULL)
		{
			fprintf(stderr,"Can't get config_port!\n");
			exit(-1);
		}
		(*config_port)(atoi(main_argv[1]));
	}

	if ((*socket_handle->start)() != 0)
	{
		fprintf(stderr,"Socket failed to start.\n");
		exit(1);
	}
	if ((*bigworld_handle->start)() != 0)
	{
		fprintf(stderr,"World failed to start.\n");
		exit(1);
	}
	return(0);
}

int config_stop(void)
{
	return(-1);
}
