#include <stdio.h>
#include "../../include/devmud.h"

struct interface config_supplies[] = {
	{NULL,NULL,NULL,NULL}
};

struct interface config_uses[] = {
	{NULL,NULL,NULL,NULL}
};

void config_use_functions(struct interface *it)
{
	return;
}

int config_initialize(void)
{
	return(0);
}

int config_start(void)
{
	struct module_handle *socket_handle, *world_handle;

	socket_handle = load_module("socket");
	world_handle = load_module("world");

	if ((*socket_handle->initialize)() != 0)
	{
		fprintf(stderr,"Socket failed to initialize.\n");
		exit(1);
	}
	if ((*world_handle->initialize)() != 0)
	{
		fprintf(stderr,"World failed to initialize.\n");
		exit(1);
	}

	world_handle->use_functions(socket_handle->supplies);

	if ((*socket_handle->start)() != 0)
	{
		fprintf(stderr,"Socket failed to start.\n");
		exit(1);
	}
	if ((*world_handle->start)() != 0)
	{
		fprintf(stderr,"World failed to start.\n");
		exit(1);
	}
	return(0);
}

int config_stop(void)
{
	return(-1);
}
