/* Example DevMUD module to load a map for another module */

#include <stdio.h>
#include "../include/devmud.h"

static void (*new_room)(char *name, char *shortdesc) = NULL;
static void (*link_exit)(char *dir, char *here, char *there) = NULL;

struct interface worldloader_supplies[] = {
	{NULL,NULL,NULL,NULL}
};

struct interface worldloader_uses[] = {
	{ "new_room", NULL, "void(char*,char*)", NULL },
	{ "link_exit", NULL, "void(char*,char*,char*)", NULL },
	{ NULL, NULL, NULL, NULL }
};

void worldloader_use_functions(struct interface *it)
{
	struct interface *temp;

	temp = it;
	while (temp->name != NULL)
	{
		if ((!strcmp(temp->name,"new_room")) &&
		    (!strcmp(temp->prototype,"void(char*,char*)")))
		{
			new_room = temp->function;
		}
		else if ((!strcmp(temp->name,"link_exit")) &&
			 (!strcmp(temp->prototype,"void(char*,char*,char*)")))
		{
			link_exit = temp->function;
		}
		temp++;
	}
	return;
}

int worldloader_initialize(void)
{
	return(0);
}

int worldloader_start(void)
{
	if ((new_room == NULL) ||
	    (link_exit == NULL))
	{
		fprintf(stderr,"Needed functions still uninitialized in worldloader_start!\n");
		return(-1);
	}

	link_exit("south", "south room", "base");

	new_room("base","Base of the tower");
	link_exit("north", "base", "south room");
	link_exit("east", "base", "hall");
	link_exit("south", "base", "field");

	new_room("field","In a grassy field");
	link_exit("north", "field", "base");
	link_exit("south", "field", "hills");

	new_room("hills","In the rolling hills");
	link_exit("north", "hills", "field");

	new_room("hall","In the hall of gateways");
	link_exit("west", "hall", "base");
	return(0);
}

int worldloader_stop(void)
{
	return(-1);
}
